<cfapplication name="MailSurfer" clientmanagement="Yes" sessionmanagement="Yes" setclientcookies="Yes" sessiontimeout="#CreateTimeSpan(0,0,30,0)#" applicationtimeout="#CreateTimeSpan(30,0,0,0)#">
<cfsavecontent variable="notes">
============================================================================
File:       mailsurfer.cfm
Title:      The CF Mail Surfer
Author:     Nathan Strutz | mrnate@hotmail.com
Date:       February 18, 2002
Version:    1.0a

Purpose:    Basically, it's a cold fusion web-based email client. I needed
            one and there weren't any simple and small, so I took to
            building it myself.

Legal:      The CF Mail Surfer is  2004 Nathan Strutz, All Rights
            Reserved. Nathan Strutz is not responsible for illegal usage of
            this program.

Allowed:    Requesting new features or suggesting changes.
            Thank the author of this great program.
            Report bugs.
            Use it. Like it.
            If you want to modify it, buy it!

Disallowed: Modifying the code.
            Redistributing.

Info:       The CF Mail Surfer is 100% self-contained. There are no
            external pages or graphics. It's easy to upload, install
            and upgrade. Cleans up with no mess. Totally biodegradable!

History:    Since it's still in alpha, this section is really boring. I'll
            spruce it up before it hits beta.
            02/18/02 - The file is born.
            03/20/02 - Moved to Phoenix.
            05/08/02 - Worked on it some.
            11/07/02 - Got working on it again.
            09/23/03 - Actually tested it, works pretty good, needs help.
			02/11/04 - Fixed some session/client/variables bugs.

Bugs:       Lots!

Future:     Email future feature requests to mrnate@dopefly.com

Help:       Anything you see that needs fixing! Mail me code or
            suggestions. Thanks!
============================================================================
</cfsavecontent>
<cfset self = GetFileFromPath(cgi.CF_TEMPLATE_PATH)>
<cfsetting showdebugoutput="no">


<html>
<head>
	<title>CF Mail Surfer</title>
	<style type="text/css">
		TABLE { font-family:arial,helvetica; font-size:10pt; }
		INPUT { font-family:arial,helvetica; font-size:10pt; border-width:1; color:#333333; background-color:#F6F6F6}
		A     { color:#666666; }
		H1    { font-size:11pt; }
		.SmallButton { font-size:7pt; }
		.MessageRow  { cursor:pointer; }
</style>
</head>

<body bgcolor="#EEEEEE">
<!--- Set some defaults --->
<cfparam name="action" default="login">

<!--- set client/session variables to locals. Beats having loads of cfifs throughout. --->
<cfif IsDefined("session.name")><cfset name = session.name><cfelseif IsDefined("client.name")><cfset name = client.name></cfif>
<cfif IsDefined("session.username")><cfset username = session.username><cfelseif IsDefined("client.username")><cfset username = client.username></cfif>
<cfif IsDefined("session.address")><cfset address = session.address><cfelseif IsDefined("client.address")><cfset address = client.address></cfif>
<cfif IsDefined("session.password")><cfset password = session.password><cfelseif IsDefined("client.password")><cfset password = client.password></cfif>
<cfif IsDefined("session.servername")><cfset servername = session.servername><cfelseif IsDefined("client.servername")><cfset servername = client.servername></cfif>

<!--- check if user is logged in. --->
<cfif NOT IsDefined("username")>
	<!--- list of ok pages, not needing login --->
	<cfif action IS NOT "login" AND action IS NOT "about" AND action IS NOT "act_login">
		<cflocation url="#self#">
	</cfif>
</cfif>



<cfswitch expression="#action#">



<cfcase value="login">
	<table border=0 cellpadding=0 cellspacing=0 width="100%" height="100%">
	  <tr>
		<td align="center">
		<cfoutput><form action="#self#?action=act_login" method="post"></cfoutput>
		<table border=1 cellpadding=0 cellspacing=0 bordercolor="#CCCCCC">
		  <tr>
			<td>
			<table border=0 cellpadding=4 cellspacing=0 width=300>
			  <tr bgcolor="#CCCCCC">
				<cfoutput><td colspan=3>Please Log In - <a href="#self#?action=about">about</a></td></cfoutput>
			  </tr>
			  <tr>
				<td colspan=3>&nbsp;</td>
			  </tr>
				<cfoutput>
			  <tr>
				<td width="33%"><input type="text" name="name" value="<cfif IsDefined("name")>#name#<cfelse>Your Name</cfif>" size="10" maxlength="100" onFocus="if(this.value == 'Your Name') this.value=''; return true;" onBlur="if(this.value == '') this.value='Your Name'; return true"></td>
				<td width="33%"><input type="text" name="login" value="<cfif IsDefined("username")>#username#<cfelse>Login Name</cfif>" size="10" maxlength="100" onFocus="if(this.value == 'Login Name') this.value=''; return true" onBlur="if(this.value == '') this.value='Login Name'; return true"></td>
				<td width="33%"><input type="text" name="servername" value="<cfif IsDefined("servername")>#servername#<cfelse>Server</cfif>" size="10" maxlength="100" onFocus="if(this.value == 'Server') this.value=''; return true" onBlur="if(this.value == '') this.value='Server'; return true"></td>
			  </tr>
			  <tr>
				<td width="33%"><input type="password" name="password" value="<cfif IsDefined("name")><!--- #password# ---><cfelse>Password</cfif>" size="10" maxlength="100" onFocus="if(this.value == 'Password') this.value=''; return true" onBlur="if(this.value == '') this.value='Password'; return true"></td>
				<td width="33%"><input type="text" name="address" value="<cfif IsDefined("address")>#address#<cfelse>Email Address</cfif>" size="10" maxlength="100" onFocus="if(this.value == 'Email Address') this.value=''; return true" onBlur="if(this.value == '') this.value='Email Address'; return true"></td>
				<td width="33%">&nbsp;</td>
			  </tr>
				</cfoutput>
			  <tr>
				<td colspan=3 align="center"><label for="rememberme"><input type="checkbox" name="rememberme" id="rememberme"> Remember me next time</label></td>
			  </tr>
			  <tr>
				<td colspan=3>&nbsp;</td>
			  </tr>
			  <tr>
				<td colspan=3 align="center"><input type="submit" value="submit"></td>
			  </tr>
			</table>
			</td>
		  </tr>
		</table>
		</form>
		</td>
	  </tr>
	</table>
</cfcase>



<cfcase value="act_login">
	<cfif IsDefined("form.name") AND IsDefined("form.password") AND IsDefined("form.address") AND IsDefined("form.login") AND IsDefined("form.servername")>
		<cfif IsDefined("form.rememberme")>
			<!--- client variables if they checked "remember me" --->
			<cfset client.name="#form.name#">
			<cfset client.username="#form.login#">
			<cfset client.address="#form.address#">
			<!--- <cfset client.password="#form.password#"> don't let passwords persist past session --->
			<cfset session.password="#form.password#">
			<cfset client.servername="#form.servername#">
			<!cflocation url="#self#?action=messages">
		<cfelse>
		<!--- session variables if they didn't check "remember me" --->
			<cfset session.name="#form.name#">
			<cfset session.username="#form.login#">
			<cfset session.address="#form.address#">
			<cfset session.password="#form.password#">
			<cfset session.servername="#form.servername#">
			<cflocation url="#self#?action=messages">
		</cfif>
		<!--- now check your mail --->
		<cflocation url="#self#?action=messages">
	<cfelse>
		<cflocation url="#self#">
	</cfif>
</cfcase>



<cfcase value="messages">
	<cftry>
		<cfpop action="GETHEADERONLY" name="msgheads" server="#servername#" username="#username#" password="#password#">
		<cfcatch type="Any">
			<cfrethrow>
			<cflocation url="#self#?action=mailerror">
		</cfcatch>
	</cftry>
	<table border=1 cellpadding=3 cellspacing=0 bordercolor="#CCCCCC">
	<cfoutput><form action="#self#?action=delete_messages" method="post"></cfoutput>
	  <tr>
		<cfoutput><td rowspan="#msgheads.recordcount+1#" valign="top" width="60" nowrap="nowrap"><a href="#self#?action=messages">Inbox</a><br><a href="#self#?action=send">Send Mail</a></td></cfoutput>
		<cfif "#msgheads.recordcount#" IS "0"><td>No messages</td></cfif>
	<cfoutput query="msgheads">
	  <cfif "#msgheads.CurrentRow#" IS NOT "1"><tr></cfif>
		<td><input type="checkbox" name="message_checkbox" value="#messagenumber#"></td>
		<td><a href="#self#?action=read&id=#messagenumber#">#from#</a></td>
		<td><a href="#self#?action=read&id=#messagenumber#">#subject#</a></td>
		<td><a href="#self#?action=read&id=#messagenumber#">#date#</a></td>
	  </tr>
	</cfoutput>
	  <tr>
		<td colspan="4"><input type="submit" value="Delete Marked Messages" class="SmallButton"></td>
	  </tr>
	</table>
</cfcase>



<cfcase value="read">
	<cfpop action="GETALL" name="thismessage" messagenumber="#url.id#" server="#servername#" username="#username#" password="#password#">
	<cfscript>
		if (IsDefined("thismessage.htmlbody") and Len(thismessage.htmlbody)) {
			messagebody = thismessage.htmlbody;
		} else {
			messagebody = "<pre>" & HTMLEditFormat(thismessage.body) & "</pre>";
		}
		// link urls
		messagebody = ReReplace(messagebody,"\b((http://)?www\.[a-zA-Z0-9\.-]*\.(([a-zA-Z]{2,3})|(aero|coop|info|museum|name))[a-zA-Z0-9&\;\/\.\?=_-]*)\b","<a href=""\1"" target=""_blank"">\1</a>","ALL");
		// link emails
		messagebody = ReReplace(messagebody,"\b(['_a-zA-Z0-9-]+(\.['_a-zA-Z0-9-]+)*@[a-zA-Z0-9-]+(\.[a-zA-Z0-9-]+)*\.(([a-zA-Z]{2,3})|(aero|coop|info|museum|name)))\b","<a href=""#cgi.script_name#?action=send&to=\1"">\1</a>","ALL");
	</cfscript>
	<table border=1 cellpadding=3 cellspacing=0 bordercolor="#CCCCCC" width=600>
	  <tr>
		<cfoutput><td rowspan="#thismessage.recordcount#" valign="top" width="60" nowrap="nowrap"><a href="#self#?action=messages">Inbox</a><br><a href="#self#?action=send">Send Mail</a></td></cfoutput>
		<td>
		<cfoutput query="thismessage">
		<table border=0 cellpadding=2 cellspacing=0 width="100%">
		  <tr bgcolor="##F0F0F0">
			<td width=100>From:</td><td>#HTMLEditFormat(from)#</td>
		  </tr>
		  <tr bgcolor="##F2F2F2">
			<td width=100>to:</td><td>#HTMLEditFormat(to)#</td>
		  </tr>
		  <tr bgcolor="##F5F5F5">
			<td width=100>cc:</td><td>#cc#</td>
		  </tr>
		  <tr bgcolor="##F8F8F8">
			<td width=100>replyto:</td><td>#replyto#</td>
		  </tr>
		  <tr bgcolor="##FBFBFB">
			<td width=100>Date:</td><td>#date#</td>
		  </tr>
		  <tr bgcolor="##FFFFFF">
			<td width=100>subject:</td><td>#subject#</td>
		  </tr>
		  <tr bgcolor="##EEEEEE">
			<td width=100 colspan=2>#messagebody#</td>
		  </tr>
		  <tr>
			<td colspan=2 align="center">
			<a href="#self#?action=reply&id=#url.id#">reply</a>&nbsp; &nbsp;<a href="#self#?action=forward&id=#url.id#">forward</a>&nbsp; &nbsp;<a href="#self#?action=deletemessage&id=#url.id#">delete</a>
			</td>
		  </tr>
		</table>
		</cfoutput>
	  </tr>
	</table>
</cfcase>



<cfcase value="reply">
	<cfpop action="GETALL" name="thismessage" messagenumber="#url.id#" server="#servername#" username="#username#" password="#password#">
	<table border=1 cellpadding=3 cellspacing=0 bordercolor="#CCCCCC" width=600>
	  <tr>
		<cfoutput><td rowspan="#thismessage.recordcount#" valign="top" width="60" nowrap="nowrap"><a href="#self#?action=messages">Inbox</a><br><a href="#self#?action=send">Send Mail</a></td></cfoutput>
		<td>
		<cfoutput query="thismessage">
		<form action="#self#?action=act_send" method="post">
		<table border=0 cellpadding=2 cellspacing=0 width="100%">
		  <tr>
			<td width=100>To:</td><td><input type="text" name="to" size="60" value="#HTMLEditFormat(from)#"></td>
		  </tr>
		  <tr>
			<td width=100>cc:</td><td><input type="text" name="cc" size="60" value="#HTMLEditFormat(cc)#"></td>
		  </tr>
		  <tr>
			<td width=100>subject:</td><td><input type="text" name="subject" size="60" value="Re: #HTMLEditFormat(subject)#"></td>
		  </tr>
		  <tr>
			<td width=100 colspan=2><textarea cols="60" rows="20" name="message">


<cfif "#Len(from)#" LT "60">======<cfloop index="divider" from="1" to="#Len(from)#">=</cfloop><cfelse>==========================================================</cfif>
From: #HTMLEditFormat(from)#
Date: #date##chr(13)##chr(13)#
#HTMLEditFormat(body)#</textarea></td>
		  </tr>
		  <tr>
			<td colspan=2 align="center">
			<input type="submit" value="Send">
			</td>
		  </tr>
		</table>
		</form>
		</cfoutput>
	  </tr>
	</table>
</cfcase>



<cfcase value="Forward">
	<cfpop action="GETALL" name="thismessage" messagenumber="#url.id#" server="#servername#" username="#username#" password="#password#">
	<table border=1 cellpadding=3 cellspacing=0 bordercolor="#CCCCCC" width=600>
	  <tr>
		<cfoutput><td rowspan="#thismessage.recordcount#" valign="top" width="60" nowrap="nowrap"><a href="#self#?action=messages">Inbox</a><br><a href="#self#?action=send">Send Mail</a></td></cfoutput>
		<td>
		<cfoutput query="thismessage">
		<form action="#self#?action=act_send" method="post">
		<table border=0 cellpadding=2 cellspacing=0 width="100%">
		  <tr>
			<td width=100>To:</td><td><input type="text" name="to" size="60" value=""></td>
		  </tr>
		  <tr>
			<td width=100>cc:</td><td><input type="text" name="cc" size="60" value="#HTMLEditFormat(cc)#"></td>
		  </tr>
		  <tr>
			<td width=100>subject:</td><td><input type="text" name="subject" size="60" value="Re: #HTMLEditFormat(subject)#"></td>
		  </tr>
		  <tr>
			<td width=100 colspan=2><textarea cols="60" rows="20" name="message">


<cfif "#Len(from)#" LT "60">======<cfloop index="divider" from="1" to="#Len(from)#">=</cfloop><cfelse>==========================================================</cfif>
From: #HTMLEditFormat(from)#
Date: #date##chr(13)##chr(13)#
#HTMLEditFormat(body)#</textarea></td>
		  </tr>
		  <tr>
			<td colspan=2 align="center">
			<input type="submit" value="Send">
			</td>
		  </tr>
		</table>
		</form>
		</cfoutput>
	  </tr>
	</table>
</cfcase>



<cfcase value="send">
	<table border=1 cellpadding=3 cellspacing=0 bordercolor="#CCCCCC" width=600>
	  <tr>
		<cfoutput><td rowspan="1" valign="top" width="60" nowrap="nowrap"><a href="#self#?action=messages">Inbox</a><br><a href="#self#?action=send">Send Mail</a></td></cfoutput>
		<td>
		<cfoutput>
		<form action="#self#?action=act_send" method="post">
		<table border=0 cellpadding=2 cellspacing=0 width="100%">
		  <tr>
			<td width=100>To:</td><td><input type="text" name="to" size="60" value=""></td>
		  </tr>
		  <tr>
			<td width=100>cc:</td><td><input type="text" name="cc" size="60" value=""></td>
		  </tr>
		  <tr>
			<td width=100>subject:</td><td><input type="text" name="subject" size="60" value=""></td>
		  </tr>
		  <tr>
			<td width=100 colspan=2><textarea cols="60" rows="20" name="message"></textarea></td>
		  </tr>
		  <tr>
			<td colspan=2 align="center">
			<input type="submit" value="Send">
			</td>
		  </tr>
		</table>
		</form>
		</cfoutput>
	  </tr>
	</table>
</cfcase>



<cfcase value="act_send">
	<cfmail to="#form.to#" from="#username#@#servername#" subject="#form.subject#" cc="#form.cc#" server="#servername#">
	#form.message#
	</cfmail>
	<cflocation url="#self#?action=messages">
</cfcase>



<cfcase value="delete_messages">
	<cfif IsDefined("form.message_checkbox")>
		<cfscript>
			reverse_list = "";
			for (i=1;i LTE ListLen(form.message_checkbox);i=1){
				reverse_list = ListAppend(reverse_list,ListLast(form.message_checkbox));
				form.message_checkbox = ListDeleteAt(form.message_checkbox,ListLen(form.message_checkbox));
			}
		</cfscript>
	
		<cfloop list="#reverse_list#" index="i">
			<cfpop action="DELETE" messagenumber="#i#" server="#servername#" username="#username#" password="#password#">
		</cfloop>
	</cfif>
	<cflocation url="#self#?action=messages">
</cfcase>



<cfcase value="mailerror">
	There seems to be a problem with your mail settings. Please go to the server log in page and try again.<br>
	<br>
	<cfoutput><a href="#self#">click here</a></cfoutput>
</cfcase>



<cfcase value="about">
	<table border=0 cellspacing=0 cellpadding=20>
	  <tr>
		<td><h1>About The CF Mail Surfer</h1><br>
		<b>What it is:</b><br>
		The CF Mail Surfer is a quick and easy all-in-one web based email client. It can be installed on any Cold Fusion server and be used to check any POP3 or IMAP email account worldwide from any location. Furthermore, it can be customized to fit the design of a specific web site, and be confined to a certain mail server for corporate usage.<br>
		<br>
		<br>
		<b>How do I use it?</b><br>
		You need to provide certain specific information, including your name, your login name, your email address, your password and your mail server address. Type this information into the login page. Click "Remember me" if you want to save this step next time. From this point on, everything is fairly intuitive. Click on a message to read it. blah blah blah. it's just like hotmail.<br>
		<br>
		<br>
		<b>Where does my information go?</b><br>
		After sending your name, password and other information, it assigns a random number to your computer in the form of a cookie. Depending on the server that Mail Surfer resides on, your information can be stored anywhere. Most likely, it will be saved in a cookie to your own computer, stored in the server's windows registry or in a secure database.<br>
		<br>
		Cold Fusion never keeps information longer than it needs to. The Mail Surfer only holds your login information for 30 minutes after your last request. Chosing to "Remember" your information makes it last for 30 days of your last request. Your password is never saved longer than current visit.<br>
		<br>
		The CF Mail Surfer only downloads your mail to your web browser. Unlike some mail programs, it saves no files to the server. Your email is removed as quickly as you close your browser or go to a different page.<br>
		<br>
		<br>
		<b>Is it secure?</b><br>
		Email is inherently insecure. Yes, you need your name and password to log in to your mail server, but after that, all your mail data is sent across the internet. Packets of your letter to Mom can be snatched up by hackers and read. Never send important data (credit card numbers, etc.) via email.<br>
		<br>
		<br>
		<b>Can I put it on my site?</b><br>
		<br>
		You can put it, just as it is, on your web site for no charge. To modify, customize and/or edit the code, you'll have to email me to discuss whatever fees may be applicable for your project. No reselling is allowed, including repackaging and selling in a bundle, except with my expressed written consent.<br>
		<br>
		To talk about purchasing filesurfer, please <a href="mailto:mrnate@dopefly.com">contact me</a>.<br>
		<br>
		<br>
		<b>More Questions?</b><br>
		<br>
		Email me! <a href="mailto:mrnate@dopefly.com">mrnate@dopefly.com</a><br>
		<br>
		<br>
		<cfoutput><b>Documentation Notes:</b><pre>#notes#</pre></cfoutput></td>
	  </tr>
	</table>
</cfcase>


<cfdefaultcase>
	you specified an invalid action.
	<!--- <cflocation url="#self#"> --->
</cfdefaultcase>



</cfswitch>
</body>
</html>
